/********************************************/
/*                                          */
/*     例題2.5 2次元ニュートン法のプログラム     */
/*                                          */
/********************************************/

#include<stdio.h>
#include<math.h>

/*関数の定義*/
#define f(X,Y) ( 2.0*(X)-sin((Y)) )
#define g(X,Y) ( 2.0*(Y)-cos((X)) )

int main(void)
{
    int i;
	double x, y, A[2][2], B[2];
	
	/*初期値を設定*/
	x=0.5;
	y=0.5;
	
	/*2次元ニュートン法を用いた反復*/
	for(i=0;i<=5;i++)
	{
		/*結果の表示*/
		printf("%d x=%f y=%f f=%f g=%f\n",i,x,y,f(x,y),g(x,y));
		
		/*左辺の２次正方行列(ヤコビ行列)Aの値の設定*/
		A[0][0]=2.0;
		A[0][1]=-cos(y);
		A[1][0]=sin(x);
		A[1][1]=2.0;
		
		/*右辺の値の設定*/
		B[0]=-f(x,y);
		B[1]=-g(x,y);
		
		/*A, Bは既知なのでAX=BよりXを計算*/
		/*ここで X=(x_n+1-x_n, y_n+1-y_n) とする*/
		A[1][1] = A[1][1]-(A[0][1]/A[0][0])*A[1][0];
		B[1]    = B[1]   -(B[0]   /A[0][0])*A[1][0];
		
		B[0]=B[0]-(B[1]/A[1][1])*A[0][1];
		
		B[0]=B[0]/A[0][0];
		B[1]=B[1]/A[1][1];
		
		/*(x_n, y_n)は既知なので*/
		/*求まったXから(x_n+1, y_n+1)を計算*/
		x=B[0]+x;
		y=B[1]+y;
	}
}


