/*************************************************/
/*                                               */
/*    例題3.2 ベアストウ−ヒッチコック法のプログラム     */
/*                                               */
/*************************************************/

#include<stdio.h>
#include<math.h>

#define a1 (0.0)
#define a2 (0.0)
#define a3 (1.0)
#define a4 (1.0)
#define a5 (-2.0)

int main(void)
{
    /*計算で必要な変数*/
    int i, j;
	double A[6], B[3], C[4], C1[5], R, S, a, b, c, d;
	
	/*係数の初期値を設定*/
	/*f(x)=A[5]x^5+A[4]x^4+A[3]x^3+A[2]x^2+A[1]x+A[0]とする*/
	A[5]=1.0;
	A[4]=a1;
	A[3]=a2;
	A[2]=a3;
	A[1]=a4;
	A[0]=a5;
	
	/*x^2+px+q=B[2]x^2+B[1]x+B[0]とする*/
	B[2]=1.0;
	B[1]=0.0;
	B[0]=1.0;
	
	/*Bairstow-Hitchcock法の反復パート*/
	for(j=0;j<=30;j++)
	{
	
		/*f(x)をB[2]x^2+B[1]x+B[0]で割る操作*/
		/*商をh(x)=C[3]x^3+C[2]x^2+C[1]x+C[0], 余りをA[1]x+A[0]とする*/
		for(i=0;i<=3;i++)
		{
			C[3-i] = A[5-i]/B[2];
		
			A[3-i] = A[3-i]-A[5-i]*B[0]/B[2];
			A[4-i] = A[4-i]-A[5-i]*B[1]/B[2];
			A[5-i] = 0.0;
		}
	
		/*余りからRとSを代入*/
		R = A[1];
		S = A[0];
	
		/*xh(x)をx^2+px+qで割る操作*/
		C1[4]=C[3];
		C1[3]=C[2];
		C1[2]=C[1];
		C1[1]=C[0];
		C1[0]=0.0;
		for(i=0;i<=2;i++)
		{
			C1[2-i] = C1[2-i]-C1[4-i]*B[0]/B[2];
			C1[3-i] = C1[3-i]-C1[4-i]*B[1]/B[2];
			C1[4-i] = 0.0;
		}
	
		a=C1[1];
		b=C1[0];
	
		/*h(x)をx^2+px+qで割る操作*/
		for(i=0;i<=1;i++)
		{
			C[1-i] = C[1-i]-C[3-i]*B[0]/B[2];
			C[2-i] = C[2-i]-C[3-i]*B[1]/B[2];
			C[3-i] = 0.0;
		}
		
		c=C[1];
		d=C[0];
	
		/*あらたなp,qの設定とf(x)の係数をもとに戻す*/
		B[1]=( d*R-c*S)/(a*d-b*c)+B[1];
		B[0]=(-b*R+a*S)/(a*d-b*c)+B[0];

		A[5]=1.0;
		A[4]=a1;
		A[3]=a2;
		A[2]=a3;
		A[1]=a4;
		A[0]=a5;
		
		/*結果の表示*/
		printf("p=%f q=%f\n", B[1],B[0]);
	}
}


