/***************************************/
/*                                     */
/*        例題3.3 DKA法のプログラム       */
/*                                     */
/***************************************/

#include<stdio.h>
#include<math.h>
#include<complex.h>

#define PI (3.14159265359)
#define f(X) ( (X)*(X)*(X)*(X)*(X)+(X)*(X)*(X)*(X)+1.0 )

int main(void)
{
    /*計算に必要な変数*/
    int i, j, k;
	double theta[5];
    double complex x[5], new_x[5], product;
	
    /*アバースの初期値の設定*/
    for(i=0;i<5;i++)
    {
        theta[i]=2.0*i*PI/5.0+3.0/10.0;
        x[i]=-1.0/5.0+(11.0/5.0)*cos(theta[i])+(11.0*I/5.0)*sin(theta[i]);
    }
    
    /*複素ニュートン法による反復*/
    /*10回繰り返す*/
    for(j=0;j<=10;j++)
    {
        /*計算結果の出力*/
        for(i=0;i<5;i++)
        {
            printf("x%d=%f%+fi ", i,creal(x[i]),cimag(x[i]));
        }
        printf("\n");
        
        /*各x^jの計算*/
        for(i=0;i<5;i++)
        {
            /*分母の積の計算*/
            product=1.0;
            for(k=0;k<5;k++)
            {
                if(k!=i)
                {
                    product=product*(x[i]-x[k]);
                }
            }
            /*値の計算*/
            new_x[i]=x[i]-f(x[i])/product;
        }
        
        /*次の反復で用いるための値の更新*/
        for(i=0;i<5;i++)
        {
            x[i]=new_x[i];
        }
	}
}


