/***************************************/
/*                                     */
/*    例題4.1 ガウスの消去法のプログラム    */
/*                                     */
/***************************************/

#include<stdio.h>
#include<math.h>

/*左辺の係数行列の定義*/
#define a11 (4.0)
#define a12 (6.0)
#define a13 (2.0)
#define a21 (2.0)
#define a22 (5.0)
#define a23 (4.0)
#define a31 (3.0)
#define a32 (4.0)
#define a33 (5.0)

/*右辺のベクトルの定義*/
#define b1 (3.0)
#define b2 (5.0)
#define b3 (6.0)


int main(void)
{
    /*計算で必要な変数*/
    int i, j, k;
	double A[3][4], X[3], sum;
	
	/*拡大係数行列の設定*/
	A[0][0]=a11;
	A[0][1]=a12;
	A[0][2]=a13;
	A[1][0]=a21;
	A[1][1]=a22;
	A[1][2]=a23;
	A[2][0]=a31;
	A[2][1]=a32;
	A[2][2]=a33;
	
	A[0][3]=b1;
	A[1][3]=b2;
	A[2][3]=b3;
	
	/*ガウスの消去法 前進過程*/
	for(i=0;i<=1;i++)
	{
		for(j=1+i;j<=2;j++)
		{
			for(k=1+i;k<=3;k++)
			{
				A[j][k]=A[j][k]-A[j][i]*A[i][k]/A[i][i];
			}
		}
	}
	
	/*ガウスの消去法 後進過程*/
	X[2]=A[2][3]/A[2][2];
	for(i=1;i>=0;i--)
	{
		sum=0.0;
		for(j=i+1;j<=2;j++)
		{
			sum=sum+X[j]*A[i][j];
		}
		
		X[i]=(A[i][3]-sum)/A[i][i];
	}
	
    /*計算結果の出力*/
	printf("x1=%f x2=%f x3=%f\n",X[0],X[1],X[2]);
}


