/*****************************************/
/*                                       */
/*     例題4.2 部分ピボット法のプログラム     */
/*                                       */
/*****************************************/

#include<stdio.h>
#include<math.h>

/*左辺の係数行列の定義*/
#define a11 (0.0)
#define a12 (1.0)
#define a13 (-2.0)
#define a14 (3.0)
#define a21 (1.0)
#define a22 (-3.0)
#define a23 (4.0)
#define a24 (-7.0)
#define a31 (-3.0)
#define a32 (9.0)
#define a33 (2.0)
#define a34 (-5.0)
#define a41 (2.0)
#define a42 (1.0)
#define a43 (2.0)
#define a44 (1.0)

/*右辺のベクトルの定義*/
#define b1 (7.0)
#define b2 (2.0)
#define b3 (1.0)
#define b4 (-3.0)

int main(void)
{
    /*計算で必要な変数*/
    int i, j, k, NUM;
	double A[4][5], X[4], tmp, max, sum;
	
	/*拡大係数行列の設定*/
    A[0][0]=a11;
    A[0][1]=a12;
    A[0][2]=a13;
    A[0][3]=a14;
    A[0][4]=b1;
    
    A[1][0]=a21;
    A[1][1]=a22;
    A[1][2]=a23;
    A[1][3]=a24;
    A[1][4]=b2;
    
    A[2][0]=a31;
    A[2][1]=a32;
    A[2][2]=a33;
    A[2][3]=a34;
    A[2][4]=b3;
    
    A[3][0]=a41;
    A[3][1]=a42;
    A[3][2]=a43;
    A[3][3]=a44;
    A[3][4]=b4;
	
	/*部分ピボット選択を行うガウスの消去法*/
	for(i=0;i<=2;i++)
	{
        /*部分ピボット選択*/
        /*a_iiからa_4iを比較し, 絶対値最大のものを探す*/
        max=0.0;
        for(j=i;j<=3;j++)
        {
            if(max<fabs(A[j][i]))
            {
                max=fabs(A[j][i]);
                NUM=j;
            }
        }
        /*a_iiより大きな値があれば, 行の入れ替え*/
        if(max>0.0)
        {
            for(j=0;j<=4;j++)
            {
                tmp=A[NUM][j];
                A[NUM][j]=A[i][j];
                A[i][j]=tmp;
            }
        }
        
        /*ガウスの消去法 前進過程*/
		for(j=1+i;j<=3;j++)
		{
			for(k=1+i;k<=4;k++)
			{
				A[j][k]=A[j][k]-A[j][i]*A[i][k]/A[i][i];
			}
		}
	}
	
	/*ガウスの消去法 後進過程*/
	X[3]=A[3][4]/A[3][3];
	for(i=2;i>=0;i--)
	{
		sum=0.0;
		for(j=i+1;j<=3;j++)
		{
			sum=sum+X[j]*A[i][j];
		}
		
		X[i]=(A[i][4]-sum)/A[i][i];
	}
	
    /*結果の表示*/
	printf("x1=%f x2=%f x3=%f x4=%f\n",X[0],X[1],X[2],X[3]);
}


