/***********************************/
/*                                 */
/*     例題4.3 LU分解のプログラム     */
/*                                 */
/***********************************/

#include<stdio.h>
#include<math.h>

int main(void)
{
    /*計算に必要な変数*/
    int i, j, k;
	double A[4][4], L[4][4], U[4][4];
	
	/*拡大係数行列の設定*/
	A[0][0]=1.0;
	A[0][1]=3.0;
	A[0][2]=1.0;
	A[0][3]=-2.0;
	A[1][0]=2.0;
	A[1][1]=4.0;
	A[1][2]=-1.0;
	A[1][3]=2.0;
	A[2][0]=3.0;
	A[2][1]=1.0;
	A[2][2]=1.0;
	A[2][3]=5.0;
	A[3][0]=4.0;
	A[3][1]=2.0;
	A[3][2]=-1.0;
	A[3][3]=6.0;
	
    /*行列UとLの初期化*/
    for(i=0;i<4;i++)
    {
        for(j=0;j<4;j++)
        {
            U[i][j]=0.0;
            L[i][j]=0.0;
        }
    }
    
    for(i=0;i<=3;i++)
    {
        L[i][0]=A[i][0]/A[0][0];
    }
    
	/*ガウスの消去法 前進過程*/
	for(i=0;i<=2;i++)
	{
		for(j=i+1;j<=3;j++)
		{
			for(k=i+1;k<=3;k++)
			{
				A[j][k]=A[j][k]-A[j][i]*A[i][k]/A[i][i];
			}
		}
        /*行列Lの要素の計算・代入*/
        for(j=i+1;j<=3;j++)
        {
            L[j][i+1]=A[j][i+1]/A[i+1][i+1];
        }
	}
	
    /*行列Uの要素の代入*/
	for(i=0;i<=3;i++)
	{
		for(j=0;j<=3;j++)
		{
			if(i<=j)
			{
				U[i][j]=A[i][j];
			}
		}
	}
	
    /*行列Lの結果の出力*/
    for(i=0;i<=3;i++)
    {
        for(j=0;j<=3;j++)
        {
            printf("%f ",L[i][j]);
        }
        printf("\n");
    }

    printf("\n");
    
    /*行列Uの結果の出力*/
    for(i=0;i<=3;i++)
    {
        for(j=0;j<=3;j++)
        {
            printf("%f ",U[i][j]);
        }
        printf("\n");
    }

}


