/*****************************************/
/*                                       */
/*       例題4.4 反復法の比較プログラム       */
/*                                       */
/*****************************************/

#include<stdio.h>
#include<math.h>

/*左辺の係数行列の定義*/
#define a11 (2.0)
#define a12 (3.0)
#define a13 (1.0)
#define a21 (2.0)
#define a22 (4.0)
#define a23 (-1.0)
#define a31 (3.0)
#define a32 (1.0)
#define a33 (-3.0)

/*右辺のベクトルの定義*/
#define b1 (1.0)
#define b2 (-2.0)
#define b3 (-3.0)

#define N (100)

int main(void)
{
    /*計算で必要な変数*/
    int i, j, k;
	double A[3][3], L[3][3], U[3][3], D[3][3], B[3];
    double sum, x[3], new_x[3], new_B[3], omega;
	
	/*行列Aの設定*/
    A[0][0]=a11;
    A[0][1]=a12;
    A[0][2]=a13;
    A[1][0]=a21;
    A[1][1]=a22;
    A[1][2]=a23;
    A[2][0]=a31;
    A[2][1]=a32;
    A[2][2]=a33;
    
    /*行列U, L, Dの設定*/
    for(i=0;i<3;i++)
    {
        for(j=0;j<3;j++)
        {
            U[i][j]=0.0;
            L[i][j]=0.0;
            D[i][j]=0.0;
        }
    }
    
    D[0][0]=A[0][0];
    D[1][1]=A[1][1];
    D[2][2]=A[2][2];
    
    L[1][0]=A[1][0];
    L[2][0]=A[2][0];
    L[2][1]=A[2][1];
    
	U[0][1]=A[0][1];
	U[0][2]=A[0][2];
	U[1][2]=A[1][2];
    
    /*連立１次方程式の右辺の設定*/
    B[0]=b1;
    B[1]=b2;
    B[2]=b3;
    
    /*ヤコビ法*/
    printf("Jacobi method\n");
    
    /*初期値の設定*/
    x[0]=0.0;
    x[1]=0.0;
    x[2]=0.0;
    
    /*ヤコビ法の反復*/
    for(k=0;k<=N;k++)
    {
        /*結果の表示*/
        printf("%d %f %f %f \n",k, x[0],x[1],x[2]);

        for(i=0;i<3;i++)
        {
            sum=0.0;
            for(j=0;j<3;j++)
            {
                sum=sum+(L[i][j]+U[i][j])*x[j];
            }
            new_x[i]=(B[i]-sum)/D[i][i];
        }
        
        for(i=0;i<3;i++)
        {
            x[i]=new_x[i];
        }
    }
    
    /*ガウス・ザイデル法*/
    printf("Gauss-Seidel method\n");
    
    /*初期値の設定*/
    x[0]=0.0;
    x[1]=0.0;
    x[2]=0.0;
    
    /*ガウス・ザイデル法の反復*/
    for(k=0;k<=N;k++)
    {
        /*結果の表示*/
        printf("%d %f %f %f \n",k, x[0],x[1],x[2]);
        
        for(i=0;i<3;i++)
        {
            sum=0.0;
            for(j=0;j<3;j++)
            {
                sum=sum+U[i][j]*x[j];
            }
            new_B[i]=B[i]-sum;
        }

        x[0]=new_B[0]/D[0][0];

        for(i=1;i<3;i++)
        {
            sum=0.0;
            for(j=0;j<=i-1;j++)
            {
                sum=sum+L[i][j]*x[j];
            }
            x[i]=(new_B[i]-sum)/D[i][i];
        }
    }

    /*SOR法*/
    printf("SOR method\n");
    
    omega=0.8;
    
    /*初期値の設定*/
    x[0]=0.0;
    x[1]=0.0;
    x[2]=0.0;
    
    /*ガウス・ザイデル法の反復*/
    for(k=0;k<=N;k++)
    {
        /*結果の表示*/
        printf("%d %f %f %f \n",k, x[0],x[1],x[2]);
        
        for(i=0;i<3;i++)
        {
            sum=0.0;
            for(j=0;j<3;j++)
            {
                sum=sum+((1.0-1.0/omega)*D[i][j]+U[i][j])*x[j];
            }
            new_B[i]=B[i]-sum;
        }
        
        x[0]=new_B[0]/(D[0][0]/omega);
        
        for(i=1;i<3;i++)
        {
            sum=0.0;
            for(j=0;j<=i-1;j++)
            {
                sum=sum+L[i][j]*x[j];
            }
            x[i]=(new_B[i]-sum)/(D[i][i]/omega);
        }
    }

    
}


