/**************************************/
/*                                    */
/*     例題 行列の固有値・固有ベクトル     */
/*                                    */
/**************************************/

#include<stdio.h>
#include<math.h>

int main(void)
{
    /*計算で必要な変数*/
    int i, j, k, l, I, J;
	double A[3][3], R[3][3], TR[3][3], tmp[3][3], U[3][3];
    double max, theta, sum;
	
	/*対角行列Aの設定*/
    A[0][0]=2.0;
    A[0][1]=1.0;
    A[0][2]=4.0;
    A[1][0]=1.0;
    A[1][1]=5.0;
    A[1][2]=-2.0;
    A[2][0]=4.0;
    A[2][1]=-2.0;
    A[2][2]=-2.0;
    
    /*行列Uの設定*/
    for(i=0;i<3;i++)
    {
        for(j=0;j<3;j++)
        {
            U[i][j]=0.0;
            if(i==j)
            {
                U[i][j]=1.0;
            }
        }
    }
    
    for(k=0;k<=10;k++)
    {
        /*計算結果の表示*/
        printf("Matrix A_%d\n",k);
        for(i=0;i<3;i++)
        {
            for(j=0;j<3;j++)
            {
                printf("%f ", A[i][j]);
            }
            printf("\n");
        }
        printf("\n");

        /*絶対値最大の非対角成分の探索*/
        max=0.0;
        for(i=0;i<2;i++)
        {
            for(j=i+1;j<3;j++)
            {
                if(max<fabs(A[i][j]))
                {
                    max=fabs(A[i][j]);
                    I=i;
                    J=j;
                }
            }
        }
        
        /*行列Rの設定*/
        for(i=0;i<3;i++)
        {
            for(j=0;j<3;j++)
            {
                R[i][j]=0.0;
                if(i==j)
                {
                    R[i][j]=1.0;
                }
            }
        }
        theta=0.5*atan(-2.0*A[I][J]/(A[I][I]-A[J][J]));
        R[I][I] = cos(theta);
        R[I][J] = sin(theta);
        R[J][I] =-sin(theta);
        R[J][J] = cos(theta);
        
        /*行列Uの計算*/
        for(i=0;i<3;i++)
        {
            for(j=0;j<3;j++)
            {
                tmp[i][j]=0.0;
                for(l=0;l<3;l++)
                {
                    tmp[i][j]=tmp[i][j]+U[i][l]*R[l][j];
                }
            }
        }
        for(i=0;i<3;i++)
        {
            for(j=0;j<3;j++)
            {
                U[i][j]=tmp[i][j];
            }
        }
        /*行列U_kの計算結果の表示*/
        printf("Matrix U_%d\n",k);
        for(i=0;i<3;i++)
        {
            for(j=0;j<3;j++)
            {
                printf("%f ", U[i][j]);
            }
            printf("\n");
        }
        printf("\n");

        
        /*行列Rの転置行列TRの設定*/
        for(i=0;i<3;i++)
        {
            for(j=0;j<3;j++)
            {
                TR[i][j]=R[j][i];
            }
        }
        
        /* A_{k+1} = TR A_{k} Rの計算 */
        /* A_{k} Rの計算 */
        for(i=0;i<3;i++)
        {
            for(j=0;j<3;j++)
            {
                tmp[i][j]=0.0;
                for(l=0;l<3;l++)
                {
                    tmp[i][j]=tmp[i][j]+A[i][l]*R[l][j];
                }
            }
        }
        /* TR A_{k} Rの計算 */
        for(i=0;i<3;i++)
        {
            for(j=0;j<3;j++)
            {
                A[i][j]=0.0;
                for(l=0;l<3;l++)
                {
                    A[i][j]=A[i][j]+TR[i][l]*tmp[l][j];
                }
            }
        }
    }
}


