/***************************************************/
/*                                                 */
/* 例題6.3 複合中点公式・複合台形公式・複合シンプソン公式を */
/*              用いた数値積分のプログラム              */
/*                                                 */
/***************************************************/

#include<stdio.h>
#include<math.h>

#define N ( 10 )
#define f(X) ( 4.0 / ( 1.0+(X)*(X) ) )

int main(void)
{
    /*計算に必要な変数*/
    int i;
	double h, sum1, sum2, sum3;
	
    /*区間をN分割する*/
	h=1.0/N;
	
    /*複合中点公式による計算*/
	sum1=0.0;
	for(i=0;i<N;i++)
	{
		sum1=sum1+h*( f((i+0.5)*h) );
	}

    /*複合台形公式による計算*/
	sum2=0.0;
	for(i=0;i<N;i++)
	{
		sum2=sum2+(h/2.0)*( f(i*h) + f((i+1.0)*h) );
	}

    /*複合シンプソン公式による計算*/
	sum3=0.0;
	for(i=0;i<N;i=i+2)
	{
		sum3=sum3+(h/3.0)*( f(i*h) + 4.0*f((i+1.0)*h) + f((i+2.0)*h) );
	}

	/*結果の表示*/
	printf("%f %f %f\n",sum1,sum2,sum3);
	printf("%f %f %f\n",sum1-M_PI,sum2-M_PI,sum3-M_PI);
}


