/*******************************************/
/*                                         */
/*  例題7.2 ホイン法と改良オイラー法のプログラム  */
/*                                         */
/*******************************************/


#include<stdio.h>
#include<math.h>

#define f(X) ( (1.0-(X))*(X) )

int main(void)
{
    /*計算に必要な変数*/
    int i, N;
	double T, h, t, x0, x1, new_x1, x2, new_x2, k1, k2, exact_x;
	
    /*時間, 初期値, 分割数の設定*/
	T=2.0;
	N=20;//分割数を変える場合はこの値を変更
    x0=0.1;
	
	x1=x0;
	x2=x0;
	
	/*時間刻み幅の設定*/
	h=T/N;

	/*時間発展*/
	for(i=0;i<=N;i++)
	{
		t=h*i;
		
		/*ホイン法による次のステップの計算*/
		k1=f(x1);
		k2=f(x1+h*k1);
		new_x1=x1+(h/2.0)*( k1+k2 );

		/*改良オイラー法による次のステップの計算*/
		k1=f(x2);
		k2=f(x2+h*k1/2.0);
		new_x2=x2+h*k2;
		
        /*厳密解*/
        exact_x=x0*exp(t)/((exp(t)-1.0)*x0+1.0);

        /*結果の表示*/
		printf("Heun  %f %f %e %f\n",t, x1, x1-exact_x,(x1-exact_x)/(h*h));
		printf("Eular %f %f %e %f\n",t, x2, x2-exact_x,(x2-exact_x)/(h*h));
        
		x1=new_x1;
		x2=new_x2;
	}
}


