/**************************************/
/*                                    */
/*  例題7.14 ルンゲ・クッタ法のプログラム  */
/*                                    */
/**************************************/

#include<stdio.h>
#include<math.h>

#define f(X) ( (1.0-(X))*(X) )

int main(void)
{
    /*計算で必要な変数*/
    int i, N;
	double T, h, t, x, x0, new_x, k[4],exact_x;
	
    /*時間と空間の分割数の設定*/
	T=2.0;
	N=20;//分割数を変える場合はこの値を変更
	
    /*初期値の設定*/
    x0=0.1;
	x=x0;
	
	/*時間刻み幅*/
	h=T/N;

	/*時間発展*/
	for(i=0;i<=N;i++)
	{
		t=h*i;
		
		/*４次ルンゲ・クッタ法による計算*/
		k[0]=f(x);
		
		k[1]=f(x+(h/2.0)*k[0]);
		
		k[2]=f(x+(h/2.0)*k[1]);
		
		k[3]=f(x+h*k[2]);
		
		new_x=x+h*( k[0]/6.0+k[1]/3.0+k[2]/3.0+k[3]/6.0 );
		
        /*厳密解*/
        exact_x=x0*exp(t)/((exp(t)-1.0)*x0+1.0);
        
        /*結果の表示*/
		printf("%f %f %e %f\n",t, x, x-exact_x, (x-exact_x)/(h*h*h*h));
        
        /*次ステップのための値の保存*/
		x=new_x;
	}
}


