/******************************************/
/*                                        */
/*             例題7.4 中点法と             */
/*       ２次アダムス・バッシュフォース法の     */
/*           数値解比較のプログラム           */
/*                                        */
/******************************************/


#include<stdio.h>
#include<math.h>

#define f(X) ( sqrt((X))*(1.0-(X))*(1.0-(X))*(1.0-(X)) )

int main(void)
{
    /*計算で必要な変数*/
    int i, N;
	double T, h, t, exact_x;
    double x0, x1, new_x, x_ini;
    
    /*時間, 分割数の設定*/
	T=50.0;
	N=500;
	
	/*時間刻み幅の設定*/
	h=T/N;
    
	/*初期値の設定*/
    x_ini=0.5;
    x0=x_ini;
    x1=x0+h*f(x0);

	for(i=0;i<=N;i++)
	{
		t=h*i;
		
		/*次の時間ステップの計算*/
        /*中点法による時間発展*/
		new_x=x0+2.0*h*f(x1);
		
        /*アダムス・バッシュフォース法による時間発展*/
        //new_x=x1+(h/2.0)*(3.0*f(x1)-f(x0));
        
        /*結果の表示*/
		printf("%f %f\n",t, x0);
        
        x0=x1;
		x1=new_x;
	}
}


