/**************************************/
/*                                    */
/*   例題7.5 ルンゲ・クッタ法のプログラム   */
/*                                    */
/**************************************/

#include<stdio.h>
#include<math.h>

#define a (1.0)
#define b (0.0)//bの値を変える場合はこの値を変更

#define f(X, Y) ( (Y) )
#define g(X, Y) ( -a*(X)-b*(Y) )

int main(void)
{
    int i, N;
	double T, h, t, x, new_x, y, new_y, k[2][4];
	
    /*時間と空間の分割数の設定*/
	T=50.0;
	N=5000;
	
    /*初期値の設定*/
	x=1.0;
	y=0.0;
	
	/*時間刻み幅*/
	h=T/N;

	/*時間発展*/
	for(i=0;i<=N;i++)
	{
		t=h*i;
		
		/*４次ルンゲ・クッタ法による計算*/
		k[0][0]=f(x,y);
		k[1][0]=g(x,y);
		
		k[0][1]=f(x+(h/2.0)*k[0][0],y+(h/2.0)*k[1][0]);
		k[1][1]=g(x+(h/2.0)*k[0][0],y+(h/2.0)*k[1][0]);
		
		k[0][2]=f(x+(h/2.0)*k[0][1],y+(h/2.0)*k[1][1]);
		k[1][2]=g(x+(h/2.0)*k[0][1],y+(h/2.0)*k[1][1]);
		
		k[0][3]=f(x+h*k[0][2],y+h*k[1][2]);
		k[1][3]=g(x+h*k[0][2],y+h*k[1][2]);
		
		new_x=x+h*( k[0][0]/6.0+k[0][1]/3.0+k[0][2]/3.0+k[0][3]/6.0 );
		new_y=y+h*( k[1][0]/6.0+k[1][1]/3.0+k[1][2]/3.0+k[1][3]/6.0 );
		
        /*結果の表示*/
		printf("%f %f\n",t, x);
        
        /*次ステップのための値の保存*/
		x=new_x;
		y=new_y;
	}
}


