/*********************************************/
/*                                           */
/*    例題8.1 ポアソン方程式の差分法のプログラム    */
/*                                           */
/*********************************************/

#include<stdio.h>
#include<math.h>

#define N (10)//分割数を変える場合はこの値を変更
#define f(X) (M_PI*M_PI*sin(((X)+1.0)*M_PI/2.0)/4.0)

int main(void)
{
    /*計算で必要な変数*/
    int i, j, k;
	double A[N-1][N],u[N-1],dx,x,sum,u_max,U_max,value,U;
	
    /*区間をN分割する*/
	dx=2.0/N;
    
    /*左辺の行列Aの設定*/
    for(i=0;i<N-1;i++)
    {
        for(j=0;j<N-1;j++)
        {
            A[i][j]=0.0;
        }
    }
    for(i=0;i<N-1;i++)
    {
        A[i][i]=2.0;
        if(i+1<N-1)
        {
            A[i][i+1]=-1.0;
            A[i+1][i]=-1.0;
        }
    }
    
    /*右辺のベクトルdx*dx*f+bの設定*/
    for(i=0;i<N-1;i++)
    {
        x=-1.0+(i+1)*dx;
        A[i][N-1]=dx*dx*f(x);
    }
    
    /*ガウスの消去法 前進過程*/
    for(i=0;i<N-2;i++)
    {
        for(j=1+i;j<N-1;j++)
        {
            for(k=1+i;k<N;k++)
            {
                A[j][k]=A[j][k]-A[j][i]*A[i][k]/A[i][i];
            }
        }
    }
    
    /*ガウスの消去法 後進過程*/
	u[N-2]=A[N-2][N-1]/A[N-2][N-2];
	for(i=N-3;i>=0;i--)
	{
		sum=0.0;
		for(j=i+1;j<=N-2;j++)
		{
			sum=sum+u[j]*A[i][j];
		}
		
		u[i]=(A[i][N-1]-sum)/A[i][i];
	}
    
    /*結果の表示*/
    u_max=0.0;
    U_max=0.0;
    for(i=0;i<N-1;i++)
    {
        U=sin((-1.0+(i+1)*dx+1.0)*M_PI/2.0);
        value=u[i]-U;
        if(u_max<fabs(value))
        {
            u_max=fabs(value);
        }
        if(U_max<fabs(U))
        {
            U_max=U;
        }
    }
    printf("%e %f\n",u_max/U_max,(u_max/U_max)/(dx*dx));
}


