/**********************************************/
/*                                            */
/*  例題8.3 熱方程式を時刻前進差分法で解くプログラム  */
/*                                            */
/**********************************************/

#include<stdio.h>
#include<math.h>

#define N (100)//分割数の設定
#define T (0.5)
#define f(X,T) (exp(-M_PI*M_PI*(T)/4.0)*sin(((X)+1.0)*M_PI/2.0))

int main(void)
{
    /*計算で必要な変数*/
    int i, k, TMAX;
	double u[N-1],new_u[N-1],r,dx,dt,t,max1,max2,U;
	
    /*区間をN分割する*/
	dx=2.0/N;
    r=0.4;//rの値の設定
    dt=r*dx*dx;
    TMAX=T/dt;
    
    /*初期値の設定*/
    for(i=0;i<N-1;i++)
    {
        u[i]=sin((-1.0+(i+1)*dx+1.0)*M_PI/2.0);
    }
    
    /*時刻前進差分による時間発展*/
    for(k=0;k<=TMAX;k++)
    {
        t=k*dt;
        
        for(i=1;i<N-2;i++)
        {
            new_u[i]=u[i]+r*(u[i-1]-2.0*u[i]+u[i+1]);
        }
        new_u[0]=u[0]+r*(-2.0*u[0]+u[1]);
        new_u[N-2]=u[N-2]+r*(u[N-3]-2.0*u[N-2]);
    
        for(i=0;i<N-1;i++)
        {
            u[i]=new_u[i];
        }
    }
    
    /*結果の表示*/
    max1=0.0;
    max2=0.0;
    for(i=0;i<N-1;i++)
    {
        U=f(-1.0+(i+1)*dx,t+dt);
        if(max1<fabs(u[i]-U))
            max1=fabs(u[i]-U);
        if(max2<fabs(U))
            max2=fabs(U);
    }
    printf("%e\n",max1/max2);
}


